#!/usr/bin/perl

# Stats Grabber for Motorola Canopy AP's
# - Scott Sanders 
# - ssanders <at> wavelengthmail <dot> com
# - 3/28/05
#
# Description:
# Gathers data in interger format for the following variables:
# * Registered SM Count
# * Temperature
# * GPS Sync Status
# * Ethernet Link Status

$argv0 = $ARGV[0]; # Host
$argv1 = $ARGV[1]; # Community String
$argv2 = $ARGV[2]; # Query
$string;

if ($argv2 eq "regCount") {
	$string = `snmpget -v 2c -c $argv1 $argv0 .1.3.6.1.4.1.161.19.3.1.7.1.0`;
	$string =~ s/.*: //;
	$string =~ s/\n$//;
	print $string;
}
elsif ($argv2 eq "tempF") {
	$string = `snmpget -v 2c -c $argv1 $argv0 .1.3.6.1.4.1.161.19.3.3.1.5.0`;
	$string =~ s/.*C\///;
	$string =~ s/&deg\;F\"\n//;
	print $string;
}
elsif ($argv2 eq "tempC") {
	$string = `snmpget -v 2c -c $argv1 $argv0 .1.3.6.1.4.1.161.19.3.3.1.5.0`;
	$string =~ s/.*: \"//;
	$string =~ s/&deg.*\n//;
	print $string;
}
elsif ($argv2 eq "ethStatus") {
	# Eth Status
	# 1 = 10 BaseT Half Duplex
	# 2 = 10 BaseT Full Duplex
	# 3 = 100 BaseTX Half Duplex
	# 4 = 100 BaseTX Full Duplex
	$string = `snmpget -v 2c -c $argv1 $argv0 .1.3.6.1.4.1.161.19.3.3.1.9.0`;
	$string =~ s/.*: \"//;
	$string =~ s/\"\n$//;
	if ($string eq "10Base-T Half Duplex") {
		print 1; }
	elsif ($string eq "10Base-T Full Duplex") {
		print 2; }
	elsif ($string eq "100Base-TX Half Duplex") {
		print 3; }
	elsif ($string eq "100Base-TX Full Duplex") {
		print 4; }
}
elsif ($argv2 eq "gpsStatus") {
	$string = `snmpget -v 2c -c $argv1 $argv0 .1.3.6.1.4.1.161.19.3.1.3.1.0`;
	# GPS Status Code
	# 1 = GPS Sync
	# 2 = GPS Lost Sync
	# 3 = Generating Sync
	$string =~ s/.*: //;
	$string =~ s/\n$//;
	print $string;
}
